import processing.video.*;

int map_x_dim = 100;
int map_y_dim = 100;
int skip_dim;
Point3d[][] points;

Capture myCapture;

void setup()
{
  size(500,500,P3D);
  
  myCapture = new Capture(this,map_x_dim,map_y_dim);
  
  points = new Point3d[map_x_dim][map_y_dim];
  skip_dim = width/map_x_dim;
  
  for (int x = 0; x < points.length; x++)
  {
    for (int y = 0; y < points[x].length; y++)
    {
      int currZ = (int) random(-50,50);
      points[x][y] = new Point3d(x*skip_dim,y*skip_dim,currZ);
    }
  }
}


int count = 0;
void draw()
{
  
  //camera(0.0, 35.0, 120.0, 250.0, 250.0, 0.0, 0.0, 1.0, 0.0);
  
  background(255);
  
  //myCapture.loadPixels();
  for (int x = 0; x < points.length-1; x++)
  {
    for (int y = 0; y < points[x].length-1; y++)
    {

        float satty = 100; // saturation
        color col = myCapture.pixels[y*myCapture.width+x];
        float R = red(col); 
        float G = green(col); 
        float B = blue(col);

        float R1 = R; 
        float G1 = G; 
        float B1 = B;
        float RY1 = (( 70*R1-59*G1-11*B1)/100);
        float BY1 = ((-30*R1-59*G1+89*B1)/100);
        float GY1 = ((-30*R1+41*G1-11*B1)/100);
        float Y   =  ( 30*R1+59*G1+11*B1)/100 ;
        float RY  = (RY1*satty)/100;
        float GY  = (GY1*satty)/100;
        float BY  = (BY1*satty)/100;
        R1  = RY + Y; 
        G1 = GY + Y; 
        B1 = BY + Y;
        R1 = constrain(R1,0,255); 
        G1 = constrain(G1,0,255); 
        B1 = constrain(B1,0,255);
        R = R1; 
        G = G1; 
        B = B1;

       col = color(R,G,B);
       stroke(col);
      
      //stroke(red(myCapture.pixels[y*myCapture.width+x])*2,green(myCapture.pixels[y*myCapture.width+x])*2,blue(myCapture.pixels[y*myCapture.width+x])*2);
      points[x][y].z = (int)brightness(myCapture.pixels[y*myCapture.width+x]);

      if (count%100000 == 0)
      {
        //println(points[x][y].z);
      }

      // Draw the line to the previous Y point
      if (y != 0)
      {
        line(points[x][y].x,points[x][y].y,points[x][y].z,
              points[x][y-1].x,points[x][y-1].y,points[x][y-1].z);
      }

      // Draw the line to the previous X point
      if (x != 0)
      {
        line(points[x][y].x,points[x][y].y,points[x][y].z,
              points[x-1][y].x,points[x-1][y].y,points[x-1][y].z);
      }
    }
  }
  
  count++;
  //noLoop();
  //saveFrame();
}

void captureEvent(Capture myCapture)
{
  myCapture.read();
}

class Point3d
{
  int x;
  int y;
  int z;
  
  public Point3d(int _x, int _y, int _z)
  {
    x = _x;
    y = _y;
    z = _z;
  }
}
